// ======================================================================
//
// DetailAppear.h
// jeff grills
//
// copyright 1997 origin systems inc
//
// ======================================================================

#ifndef DETAIL_APPEAR_H
#define DETAIL_APPEAR_H

// ======================================================================

class Iff;
class Material;

#include "MultiAppear.h"

// ======================================================================

class DetailAppear : public MultiAppear
{
private:

	static bool superEnabled;
	static bool farEnabled;
	static int  globalForcedLevel;
	static int  globalMaxLevel;

protected:

	int      *levelTable;
 	real     *normalRangeSquaredTable;
	real     *superRangeSquaredTable;

	real            farSize;
	real            farRangeSquared;
	const Material *farMaterial;

protected:

	const real   *getRangeSquaredTable(void) const;
	const Appear *getRangedAppear(real rangeSquared) const;
	const Appear *getExplicitDetailLevel(int wantLevel) const;

private:

	// disable the copy constructor and the assignment operator
	DetailAppear(void);
	DetailAppear(const DetailAppear &);
	DetailAppear &operator =(const DetailAppear &);

public:

	static void setSuperEnabled(bool enabled);
	static void setFarEnabled(bool enabled);

	static void setGlobalForcedLevel(int newLevel);
	static int  getGlobalForcedLevel(void);

	static void setGlobalMaxLevel(int newLevel);
	static int  getGlobalMaxLevel(void);

public:

	DetailAppear(const char *iffname, Iff &iff, real scale);
	~DetailAppear(void);

	virtual const Appear *getRenderAppear(Camera &camera, const Object *object) const;
	virtual void          render(Camera &camera, const Xform &xform) const;
};

// ======================================================================

inline void DetailAppear::setSuperEnabled(bool enabled)
{
	superEnabled = enabled;
}

// ----------------------------------------------------------------------

inline void DetailAppear::setFarEnabled(bool enabled)
{
	farEnabled = enabled;
}

// ----------------------------------------------------------------------

inline void DetailAppear::setGlobalForcedLevel(int newLevel)
{
	globalForcedLevel = newLevel;
}

// ----------------------------------------------------------------------

inline int DetailAppear::getGlobalForcedLevel(void)
{
	return globalForcedLevel;
}

// ----------------------------------------------------------------------

inline void DetailAppear::setGlobalMaxLevel(int newLevel)
{
	globalMaxLevel = newLevel;
}

// ----------------------------------------------------------------------

inline int DetailAppear::getGlobalMaxLevel(void)
{
	return globalMaxLevel;
}

// ======================================================================

#endif
